<script setup lang="ts">
import { computed, onMounted, type PropType, ref } from "vue";
import type { ExtendedColors, SizeModifierType } from "@/types/PropTypes";

const model = defineModel({ required: true });
const props = defineProps({
  parameter: {
    type: Object,
    required: true,
  },
  required: Boolean,
  helpId: {
    type: String,
  },
  sizeModifier: {
    type: String as PropType<SizeModifierType>,
  },
  border: String as PropType<ExtendedColors>,
  id: String,
  customValidity: { type: String, required: false },
});

const dynamicCssClass = computed<string[]>(() => {
  const cssClasses = [];
  if (props.sizeModifier) {
    cssClasses.push(`form-control-${props.sizeModifier}`);
  }
  if (!helpTextPresent.value) {
    cssClasses.push("rounded-end");
  }
  if (props.border) {
    cssClasses.push("border", `border-${props.border}`);
  }
  return cssClasses;
});

const dateInput = ref<HTMLInputElement | undefined>(undefined);
const helpTextPresent = computed<boolean>(() => props.parameter["help_text"]);

const inputType = computed(() => {
  switch (props.parameter["format"]) {
    case "date":
      return "date";
    case "date-time":
      return "datetime-local";
    case "time":
      return "time";
    default:
      return "text";
  }
});

onMounted(() => {
  dateInput.value?.setCustomValidity(props.customValidity ?? "");
});
</script>

<template>
  <input
    :id="id"
    ref="dateInput"
    v-model="model"
    class="form-control"
    :class="dynamicCssClass"
    :type="inputType"
    :required="props.required"
    :aria-describedby="props.helpId"
  />
</template>

<style scoped></style>
